<template>
  <ob-modal
    ref="logchainsModalError"
    title="Ошибка при поиске логцепочки"
    size="large"
    isError
    isConfirm
    isShowControls
    okText="Закрыть"
    cancelText="Попробовать ещё раз"
    data-qa="logchainsModalError"
    custom-class="ob-logchains-modal-error-wrapper"
    @submit="$emit('submit')"
    @cancel="$emit('cancel')"
  >
    <div class="ob-logchain-modal">
      <p>
        Функционал отправки груза находится в стадии бета-тестирования. Если
        ошибка будет повторяться, свяжитесь со службой технической поддержки по
        телефону
        <a :href="`tel:${$options.contacts[platform].linkphone}`">{{
          $options.contacts[platform].phone
        }}</a>
        (с 9:00 до 18:00 с пн-пт) или по почте
        <a :href="`mailto:${$options.contacts[platform].email}`">{{
          $options.contacts[platform].email
        }}</a
        >. Номер вашего заказа: {{ orderNumber }}.
      </p>
      <template v-if="errors.length > 0">
        <div class="more-info" :class="{ 'more-info--opened': showErrors }">
          <span @click="showErrors = !showErrors">
            <i class="icon chevron-right"></i>
            Больше информации
          </span>
        </div>
        <expand-transition>
          <div v-if="showErrors">
            <ob-table :columns="errorColumns" :items="errors" footerDisabled>
            </ob-table>
          </div>
        </expand-transition>
      </template>
    </div>
  </ob-modal>
</template>

<script>
import { contacts } from "@/resources/contacts";
import ObModal from "common-components/src/obComponents/obModal";
import expandTransition from "common-components/src/obComponents/obExpandTransition";
import obTable from "common-components/src/obComponents/obTable";

export default {
  name: "orderLogchainError",

  props: {
    errors: {
      type: Array,
      default: () => [],
    },

    orderNumber: {
      type: String,
      required: true,
    },
  },

  components: {
    ObModal,
    expandTransition,
    obTable,
  },

  contacts,

  data() {
    return {
      showErrors: false,
      errorColumns: [
        {
          title: "№ логцепочки",
          key: "logchainNumber",
        },
        {
          title: "Ошибка",
          key: "errorDescription",
        },
      ],
    };
  },

  computed: {
    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? "oboz"
        : "gruzi";
    },
  },

  methods: {
    open() {
      this.$refs.logchainsModalError.open();
    },
    close() {
      this.$refs.logchainsModalError.close();
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-logchains-modal-error-wrapper {
  .ob-logchain-modal {
    a {
      text-decoration: none;
      color: $color-blue-smalt;
    }

    &::v-deep {
      td:first-child {
        white-space: nowrap;
      }
    }
  }

  .w100 {
    width: auto !important;
  }

  .ob-button-container.primary-type.danger {
    background: #0070a6;
    color: #fff;
  }

  .more-info {
    margin-top: 40px;
    padding: 0 20px;
    height: 39px;
    display: flex;
    align-items: center;
    background-color: $blue-250;
    font-size: 14px;
    color: $color-blue-smalt;

    &--opened {
      .icon {
        transform: rotate(90deg);
      }
    }

    .icon {
      margin-right: 14px;
      font-size: 16px;
      transition: transform 0.3s ease-in-out;
    }

    span {
      display: flex;
      align-items: center;
      cursor: pointer;
    }
  }
}
</style>
